%if 0

Memory test program

Copyright (C) 1995-2003 Paul Vojta
Copyright (C) 2008-2025 E. C. Masloch

Usage of the works is permitted provided that this
instrument is retained with the works, so that any entity
that uses the works is notified of this instrument.

DISCLAIMER: THE WORKS ARE WITHOUT WARRANTY.

%endif

	cpu 8086

%include "lmacros3.mac"
%include "eld.mac"

ELDCODESIZE equ 8192
ELDDATASIZE equ 8192

TOLOWER		equ 32
TOUPPER		equ ~32
TOUPPER_W	equ ~(32<<8|32)

	%imacro section_of 1-*.nolist
%rep %0
%xdefine SECTION_OF_%1 _CURRENT_SECTION
%rotate 1
%endrep
	%endmacro

	%imacro check_section_of 1.nolist
%ifndef SECTION_OF_%1
 %error No section specified for symbol %1
%elifnidni SECTION_OF_%1, _CURRENT_SECTION
 %error Wrong section for symbol %1: section_of=SECTION_OF_%1, current=_CURRENT_SECTION
%endif
	%endmacro

	%imacro section_of_function 0-1.nolist
check_section_of %1%00
%00:
	%endmacro

%macro doscall 0
	int 21h
%endmacro

%assign _EXTENSIONS 1
%assign _ELDTRAILER 1
%assign _LINKHASH 1
%assign _APPLICATION 1
%assign _DEVICE 0
%assign _BOOTLDR 0
%assign _PM 0
%assign _LINK 1
%assign _DUALCODE 0
%assign _MESSAGESEGMENT 0

%assign _CATCHINT0C 0
%assign _CATCHINT0D 0
%assign _CATCHINTFAULTCOND 0
%assign _DEBUG 0
%assign _DELAY_BEFORE_BP 0
%assign _DHIGHLIGHT 0
%assign _GETLINEHIGHLIGHT 0
%assign _IMMASM 0
%assign _INPUT_FILE_BOOT 0
%assign _INPUT_FILE_HANDLES 0
%assign _MS_0RANGE_COMPAT 0
%assign _RH 0
%assign _SYMBOLIC 0
%assign _VXCHG 0

%include "options.mac"

addsection CODE, class=TEST
section_of puts, putsz, putc, putsline, putsline_crlf, trimputs
section_of yy_open_file, yy_check_lfn, hexword, hexbyte, setrc
section_of copy_single_counted_string, intchk
section_of ispm, test_d_b_bit, test_high_limit, setes2dx
section_of call_int2D, _doscall, doscall_extseg

section_of do_uppercase
section_of skipcomma
section_of skipcomm0
section_of skipequals
section_of skipwhite
section_of skipwh0
section_of cmd3_not_ext
section_of error
section_of cmd3
section_of disp_dxax_times_cx_width_bx_size
section_of disp_dxax_times_cx_width_bx_size.store
section_of setds2si
section_of setds2bx
section_of getword
section_of chkeol
section_of cmd3_not_ext
section_of error
section_of skipcomma
section_of isstring?
section_of cmd3
section_of chkeol
section_of skipequals
section_of skipcomm0
section_of getword
section_of iseol?
section_of setds2si
section_of disp_dxax_times_cx_width_bx_size.store
section_of setds2bx

..start:
	cli
	mov ax, GROUP
	mov ss, ax
	mov sp, stacktop wrt GROUP
	sti
	mov word [ss:pspdbe], ds
	mov es, ax
	mov ax, ds
	mov di, cmdline.psp
	call hexword
	mov ah, 52h
	int 21h
	mov ax, [es:bx - 2]
	mov word [ss:firstmcb], ax
	push ds
	call init_eld
	pop ds
	 push ds
	 pop es
parsecommandline:
	mov si, 81h
@@:
	lodsb
	cmp al, 9
	je @B
	cmp al, 32
	je @B
	cmp al, 13
	je parseenvironment
	mov ah, 0
	dec si
	mov di, si
	mov dx, si
@@:
	lodsb
	cmp al, 13
	je .cr
	cmp al, 9
	je .blank
	cmp al, 32
	je .blank
	cmp al, '"'
	je .quote
.sto:
	stosb
	jmp @B

.cr:
	test ah, ah
	jnz invalidcommandline
.end:
	mov al, 0
	stosb
	jmp gotname

.blank:
	test ah, ah
	jz .end
	jmp .sto

.quote:
	xor ah, al
	jmp @B

invalidcommandline:
	push ss
	pop ds
	mov dx, msg.invalidcommandline
	call putsz_error
	mov ax, 4CFFh
	int 21h

invalidenvironment:
	push ss
	pop ds
	mov dx, msg.invalidenvironment
	call putsz_error
	mov ax, 4CFFh
	int 21h

parseenvironment:
	mov ax, [2Ch]
	test ax, ax
	jz invalidenvironment
	mov es, ax
	xor di, di
	mov cx, 7FFFh
	mov al, 0
@@:
	repne scasb
	scasb
	loopne @B
	jcxz invalidenvironment
	mov ax, 1
	scasw
	jne invalidenvironment
	push es
	pop ds
	mov dx, di
	jmp gotname

gotname:
	mov bx, dx
	call yy_open_file

	mov dx, GROUP
	mov ds, dx
	mov es, dx
	jmp ext_finish


setrc: section_of_function
	retn

yy_disp_error_1:
	push ss
	pop ds
	call putsz
	mov ax, 4CFFh
	int 21h


%if _PM == 0 && _LINK
ispm: section_of_function
	test sp, sp			; NZ, NC
	retn

test_d_b_bit: section_of_function
test_high_limit: section_of_function
	cmp al, al			; ZR, NC
	retn

setes2dx: section_of_function
	mov es, dx
	retn

call_int2D: section_of_function
	int 2Dh
	retn

_doscall: section_of_function
doscall_extseg: section_of_function
	int 21h
	retn
%endif


		; INP:	byte [ds:si] = length of source string
		;	ds:si + 1 -> source string
		;	es:di -> destination buffer
		; OUT:	cx = 0
		;	ZR, NC
		;	ds:si -> after source string
		;	es:di -> after written string
		; CHG:	-
		; STT:	UP
copy_single_counted_string: section_of_function
	xchg ax, cx
	xor ax, ax
	lodsb
	xchg ax, cx
	rep movsb
	retn


		; INP:	al = interrupt number
		; OUT:	ds:bx -> vector in IVT
		;	DI
		; STT:	86 Mode
access_ivt_86m:
	xor bx, bx
	mov ds, bx
	mov bl, al
	add bx, bx
	add bx, bx		; ds:bx -> interrupt vector
	cli
	retn


%if _PM
get_86m_interrupt_handler_no_dos:
	call ispm
	jnz get_86m_interrupt_handler.rm_indos
%endif

		; INP:	al = interrupt number
		; OUT:	dx:bx = 86 Mode far pointer
		; CHG:	ah
get_86m_interrupt_handler:
%if _PM
	call ispm
	jnz .rm

	push ax
	push cx
	xchg ax, bx		; bl = interrupt number
	mov ax, 0200h
	int 31h			; cx:dx = interrupt vector
	xchg cx, bx		; bx:dx
	xchg bx, dx		; dx:bx
	pop cx
	pop ax
	retn

.rm:
%endif

	call InDOS
	jz .notindos
%ifn _PM
get_86m_interrupt_handler_no_dos: equ $
%endif
.rm_indos:
	push ds
%if 0 && _PM
   push ax
  call push_if
%else
  pushf
%endif
	call access_ivt_86m
	mov dx, word [bx + 2]
	mov bx, word [bx]
%if 0 && _PM
  call pop_if
%else
  popf
%endif
	pop ds
	retn

.notindos:
	 push es
	mov ah, 35h
	int 21h
	mov dx, es
	 pop es
	retn


InDOS:
	cmp al, al
	retn


		; INP:	al = interrupt number
		; OUT:	ZR if offset = -1 or segment = 0
		;	NZ else
		; CHG:	ah, dx, bx
intchk: section_of_function
	call get_86m_interrupt_handler
	inc bx
	jz @F			; was 0FFFFh -->
	test dx, dx
	; jz @F			; was 0000h -->
@@:
	retn


		; INP:	ds:bx -> filename
		; OUT:	File opened,
		;	 ax = file handle
		; STT:	ds = es = ss = debugger data selector/segment
yy_open_file: section_of_function
	mov di, bx
	call .setup_opencreate			; ds:si -> pathname
	mov ax, 716Ch				; LFN open-create
	push di
	xor di, di				; alias hint
	stc
	doscall
	pop di
	jnc .got		; LFN call succeeded -->

		; Early case for no-LFN-interface available.
	; cmp ax, 1
	; je .try_sfn
	cmp ax, 7100h
	je .try_sfn

	call yy_check_lfn
	jnc .error		; if LFN interface is available, actual error
				; if LFN interface is not available, try SFN

.try_sfn:
	call .setup_opencreate
	mov ax, 6C00h				; Open-create
	stc
	doscall
	jnc .got

	cmp ax, 1
	je .try_old_open
	cmp ax, 6C00h
	jne .error

.try_old_open:
	mov al, bl				; access and sharing modes
	mov ah, 3Dh				; Open
	mov dx, si				; -> filename
	stc
	doscall
	jnc .got

.error:
	mov ax, 030Ah
	call setrc
	mov dx, msg.yy_error_file_open
	jmp yy_disp_error_1

.setup_opencreate:
	mov si, di				; -> filename
	mov bx, 0110_0000_1010_0000b		; Auto-commit, no int 24h
						; No inherit
						; DENY WRITE, Read-only
	xor cx, cx				; create attribute
	mov dx, 0000_0000_0000_0001b		; no create / open, no truncate
.got:
	retn


		; INP:	ds:si -> pathname, possibly with drive letter
		; OUT:	NC if LFN services available
		;	CY if no LFN services available
yy_check_lfn: section_of_function
		; Only now, we check whether the used drive supports LFNs.
		; If it does, then we treat the error received as an
		; actual error and cancel here. If not, the SFN function
		; is called next as a fallback.
		;
		; We cannot rely on specific error returns like the
		; expected 7100h CY (or 7100h CF-unchanged) or the similar
		; 0001h CY (Invalid function) because no one agrees on what
		; error code to use.
		;
		; dosemu returns 0003h (Path not found) on FATFS and
		; redirected-non-dosemu drives. But may be changed so as to
		; return 0059h (Function not supported on network).
		; MSWindows 98SE returns 0002h (File not found) on
		; DOS-redirected drives.
		; DOSLFN with Fallback mode enabled supports the call (albeit
		; limited to SFNs).
		;
		; To suss out what the error means, check LFN availability.
		;
		; Refer to https://github.com/stsp/dosemu2/issues/770
	push ds
	push es
	push di
	push ax
	lframe
	lvar 34, fstype_buffer
	lvar 4, pathname_buffer
	lenter

	lodsw			; load first two bytes of pathname

	push ss
	pop ds
	mov dx, sp		; ds:dx -> ?pathname_buffer
	push ss
	pop es
	mov di, sp		; es:di -> ?pathname_buffer

	cmp ah, ':'		; starts with drive specifier ?
	je @F			; yes -->

	mov ah, 19h
	doscall			; get current default drive
	add al, 'A'		; A: = 0, convert to drive letter
	mov ah, ':'		; drive specifier
@@:
	stosw
	mov ax, '\'		; backslash and zero terminator
	stosw			; es:di -> ?fstype_buffer

	xor ax, ax
	mov cx, 34 >> 1
	push di
	rep stosw		; initialise ?fstype_buffer to all zeros
	pop di			; -> ?fstype_buffer

	mov cx, 32		; size of ?fstype_buffer
	xor bx, bx		; harden, initialise this
	mov ax, 71A0h		; get volume information
	stc
	doscall			; (depends on ds = es = ss)

	jc @F			; if call not supported -->
				; bx = FS flags
	test bh, 0100_0000b	; LFN interface available ?
	stc			; if no
	jz @F			; no -->

	clc			; is available
@@:

	lleave
	pop ax			; (restore error code)
	pop di
	pop es
	pop ds
	retn


 %define extcall nearcall
 %define extcallcall nearcall
 %imacro internalcoderelocation 0-*.nolist
 %endmacro
 %imacro internaldatarelocation 0-*.nolist
 %endmacro
 %imacro linkdatarelocation 0-*.nolist
 %endmacro
 %define relocated(address) address
 %assign ELD 0

ext_finish:
	mov word [ext_handle], ax
	xchg bx, ax

%include "loadeld.asm"

 %undef extcall
 %undef extcallcall
 %unimacro internalcoderelocation 0-*.nolist
 %unimacro internaldatarelocation 0-*.nolist
 %unimacro linkdatarelocation 0-*.nolist
 %undef relocated

	cmp ax, 0FF00h
	jb @F
	push ss
	pop es
	push ss
	pop ds
	mov di, msg.eld_error_code
	call hexword
	mov dx, msg.eld_load_error
	call putsz_error
	mov ax, 4CFFh
	int 21h

@@:
	mov ax, 4C00h
	int 21h


.error_internal:
	mov dx, msg.ext_error_internal
	jmp @F

.io_error:
	mov dx, msg.ext_error_io
	jmp @F

.invalid:
	mov dx, msg.ext_error_invalid
	jmp @F

.oom:
	mov dx, msg.ext_error_oom

@@:
	push ss
	pop ds
	call putsz_error
	mov ax, 4CFFh
	int 21h


.transfer:
transfer_ext_cx_NC:
	clc

transfer_ext_cx:
	push word [ss:extseg]		; => code
	push cx				; -> entrypoint
	retf


		; Display ASCIZ message
		;
		; INP:	ds:dx -> ASCIZ message to display
		; CHG:	-
		; STT:	ds, es don't care
putsz_error:
putsz:
	push es
	push ax
	push bx
	push cx
	push dx
	push di
	 push ds
	 pop es
	mov di, dx
	mov cx, -1
	mov ax, 4000h
	repne scasb
	not cx
	dec cx
	mov bx, 1
	int 21h
	pop di
	pop dx
	pop cx
	pop bx
	pop ax
	pop es
	retn


hexword: section_of_function
	xchg al, ah
	call hexbyte
	xchg al, ah
hexbyte: section_of_function
	push cx
	mov cl, 4
	rol al, cl
	call hexnyb
	rol al, cl
	pop cx
hexnyb:
	push ax
	and al, 15
	add al, '0'
	cmp al, '9'
	jbe @F
	add al, 'A' - ('9' + 1)
@@:
	stosb
	pop ax
	retn


init_eld:
	push ss
	pop ds
	push ss
	pop es
	mov ax, word [extseg_size]
	mov di, word [extseg_used]
	sub ax, di			; = amount free space
	jc .ret
	cmp ax, eld_linkcall_size	; enough ?
	jb .ret
	mov ax, di			; -> where to install this ELD
	mov es, word [extseg]		; es:di -> where to place ELD instance
	; push cs
	; pop ds				; ! ds no longer equals ss
	mov si, eld_linkcall + 2	; ds:si -> ELD source plus one word
	mov cx, eld_linkcall_size_w - 2	; cx = length less two words
	stosw				; init eldiStartCode
	movsw
	add word [es:di - 2], ax	; init eldiEndCode
	rep movsw			; write our ELD
	push ss
	pop ds
	mov word [extseg_used], di	; -> behind ELD
	add ax, eld_linkcall.to_code1 - eld_linkcall
	mov word [linkcall_table.code1], ax
	add ax, eld_linkcall.to_entry - eld_linkcall.to_code1
	mov word [linkcall_table.entry], ax
	mov word [linkcall_table.init], 1
.ret:
	push ss
	pop ds
	push ss
	pop es
	retn


code_ret_to_ext:
entry_ret_to_ext:
	retf

putc: section_of_function
	push ax
	push dx
	xchg dx, ax
	mov ah, 02h
	int 21h
	pop dx
	pop ax
	retn

trimputs: section_of_function
	dec di
	cmp byte [es:di], 32
	je trimputs
	inc di

putsline_crlf: section_of_function
	mov ax, 0Dh + (0Ah << 8)
	stosw

putsline: section_of_function
	mov dx, line_out
	mov cx, di
	sub cx, dx

puts: section_of_function
	push ds
	 push es
	 pop ds
@@:
	mov bx, 1
	mov ah, 40h
	int 21h
	pop ds
dmycmd:
	retn

disp_message_length_cx:
	push ds
	jmp @B


%define PREFIX
%include "isstring.asm"

cmd3_not_ext: section_of_function
error: section_of_function
	push ss
	pop ds
	mov dx, msg.error
	call putsz
	mov ax, 4CFFh
	int 21h

cmd3: section_of_function
	mov ax, 4C00h
	int 21h

		; INP:	dx:ax = numerator
		;	cx = multiplier (0 to take si:dx:ax as numerator)
		;	bx = field width
		;	es:di -> buffer where to store
		; STT:	UP, ds = ss
		; OUT:	written to buffer, es:di -> behind written string
disp_dxax_times_cx_width_bx_size: section_of_function
	db __TEST_IMM8		; (skip stc, NC)
.store: section_of_function disp_dxax_times_cx_width_bx_size
	stc

	lframe near
	lequ 4 + 4 + 2,		buffer_size
		; 4: "2048" or "26.5" (maximum number)
		; 4: " ?iB" (IEC prefixed unit)
		; 2: ???
	lvar ?buffer_size,	buffer
	lvar 6,			dividend
	lenter
	lvar word,		bit_0_is_store
	 pushf
	lvar word,		width
	 push bx
	push si
	push ds
	push cx
	push ax
	push dx
	push es
	push di

	 push ss	; push cs
	 pop ds
	 push ss
	 pop es

	jcxz .use_si

	push dx
	mul cx
	xchg ax, di
	xchg dx, si		; si:di = first mul

	pop ax
	mul cx
	add ax, si
	adc dx, 0		; dx:ax = second mul + adj, dx:ax:di = mul

	jmp @F

.use_si:
	mov di, ax
	xchg ax, dx
	mov dx, si

@@:
	mov word [bp + ?dividend], di
	mov word [bp + ?dividend + 2], ax
	mov word [bp + ?dividend + 4], dx

		; set up divisor for the unit prefixes
	mov cx, 1024		; 1000 here if SI units
	testopt [options], use_si_units	; SI units ?
	jz @F			; no -->
	mov cx, 1000		; yes, use 1000
@@:

	mov si, msg.prefixes	; -> first prefix (blank)
	xor dx, dx		; init remainder (not really needed)
.loop:
	cmp word [bp + ?dividend + 4], 0
	jnz .divide
	cmp word [bp + ?dividend + 2], 0
	jnz .divide
	cmp word [bp + ?dividend], 2048
				; is dividend <= 2048 ?
	jbe .end		; yes, end unit division loop -->
.divide:
	inc si			; -> next prefix

	xor dx, dx
	mov di, 6
.loop_divide:
	mov ax, [bp + ?dividend - 2 + di]
	div cx
	mov word [bp + ?dividend - 2 + di], ax
	dec di
	dec di
	jnz .loop_divide
				; dx = last remainder
	jmp .loop

.end:
				; dx = last remainder
	mov ax, 10		; ax = 10
	mul dx			; dx:ax = last remainder * 10
	div cx			; divide by unit multiplier,
				;  ax = 0..9 tenth digit
	xchg dx, ax		; dl = 0..9 tenth digit

	lea di, [bp + ?buffer + ?buffer_size - 1]
	std			; _AMD_ERRATUM_109_WORKAROUND does not apply
	mov al, "B"
	stosb
	lodsb			; al = prefix (blank or kMGT)
	cmp al, 32		; unit is Bytes ?
	je @FF			; yes, skip past unit handling -->

	testopt [options], use_si_units
				; SI units ?
	jnz @F			; yes -->
	and al, ~20h		; uppercase, don't do this if SI units
	testopt [options], use_jedec_units
				; JEDEC units ?
	jnz @F			; yes -->
	push ax
	mov al, "i"
	stosb			; don't store this if SI or JEDEC units
	pop ax			; preserve unit prefix
@@:
	stosb			; store prefix letter
@@:
	cmp al, 32		; unit is Bytes ?
	 mov al, 32
	 stosb			; (store a blank)
	 mov ax, word [bp + ?dividend]
				; (ax = dividend, <= 2048)
	je @F			; yes, no tenth digit to display -->
	cmp ax, 100		; displaying above-or-equal 100 ?
	jae @F			; yes, display no tenth digit -->
	xchg ax, dx		; al = tenth digit
	add al, '0'		; make it text
	stosb			; store fractional digit
	mov al, '.'
	stosb			; store decimal point
	xchg ax, dx		; get back ax = dividend
@@:
	mov cx, 10
.loop_write:
	xor dx, dx
	div cx
	xchg ax, dx
				; ax = remainder (next digit)
				; dx = result of div
	add al, '0'
	stosb
	xchg ax, dx		; ax = result of div
	test ax, ax		; any more ?
	jnz .loop_write		; loop -->

	cld

	inc di			; -> first digit
	lea bx, [bp + ?buffer + ?buffer_size]
				; -> behind 'B'
	sub bx, di		; = length of string
	mov si, di

	pop di
	pop es			; restore es:di
				; -> where to store (if storing)

	mov cx, [bp + ?width]
	sub cx, bx
	jbe .none_blank
	mov al, 32
	test byte [bp + ?bit_0_is_store], 1
	jnz @F
.loop_blank_disp:
	call putc
	loop .loop_blank_disp
		; now cx = 0 so the rep stosb is a nop
@@:
	rep stosb
.none_blank:


	mov cx, bx
	test byte [bp + ?bit_0_is_store], 1
	jnz @F

		; ! note ss = ds
	mov dx, si		; ds:dx -> string
	call disp_message_length_cx
	db __TEST_IMM16		; (skip rep movsb)
@@:
		; ! note ss = ds
		; ds:si -> string, cx = length
	rep movsb

	pop dx
	pop ax
	pop cx
	pop ds
	pop si
	pop bx
	lleave
	lret


setds2si: section_of_function
	mov ds, si
	retn
setds2bx: section_of_function
	mov ds, bx
	retn

@@:
	retn
@@:
	lodsb
	call iseol?
	je @BB
	cmp al, 9
	je @BB
	cmp al, 32
	je @BB
	cmp al, ','
	je @BB
	db __TEST_IMM16		; skip xor
getword: section_of_function
	xor dx, dx
	cmp al, 'a'
	jb @F
	cmp al, 'z'
	ja @F
	xor al, 20h
@@:
	sub al, '0'
	jb error
	cmp al, 9
	jbe .sum
	sub al, - '0' - 10 + 'A'
	cmp al, 10
	jb error
	cmp al, 15
	ja error
.sum:
	mov ah, 0
	add dx, dx
	add dx, dx
	add dx, dx
	add dx, dx
	add dx, ax
	jmp @BB

		; Check for end of line
		;
		; INP:	al = first character
		;	ds:si-> next character
		; OUT:	ZR
		;	al = 13 or al = ';' or al = 0
		;	(does not return if anything on line beside blanks)
chkeol: section_of_function
	call skipwh0
	call iseol?
	je iseol?.ret		; if EOL -->

@@:
	mov ax, 0100h
	call setrc
errorj8:
	jmp error

addsection DATA, align=16 class=TEST

internalflags4:	dd 0
internalflags6:	dd 0
options:	dd 0
options7:	dd 0
build_option_PM equ _PM
try_debugger_amis_multiplex_number:
		db 0
amis_multiplex_number:
		db 0
lastcmd:	dw 0
ext_command_handler:	dw 0
firstmcb:	dw 0

eldheader:	dd 0
extcssel:
extdssel:
extseg:		dw ELDCODE
extseg_size:	dw ELDCODESIZE
extseg_used:	dw 0
extdata:	dw ext_data_area
extdata_size:	dw ELDDATASIZE
extdata_used:	dw 0
ext_handle:	dw -1
ext_cmdline:	dw cmdline
linkinfoaddress:dw linkinfo
code_seg:
pspdbg:		dw GROUP
pspdbe:		dw 0

	align 2, db 0
linkcall_table:
.init:	dw 0
	dw (.end - .) / 2
.:
	dw 0
.code1:	dw 0
 %if _DUALCODE
	dw 1
.code2:	dw 0
 %endif
	dw 2
.entry:	dw 0
.end:

extcall_table:
.ret:
	dw entry_ret_to_ext
 %if _PM
	dw 0
 %endif
	dw code_ret_to_ext
 %if _PM
	dw 0
 %endif
 %if _DUALCODE
	dw code2_ret_to_ext
  %if _PM
	dw 0
  %endif
 %endif

.segsel:
	dw pspdbg
 %if _PM
	dw cssel
 %endif
	dw code_seg
 %if _PM
	dw code_sel
 %endif
 %if _DUALCODE
	dw code2_seg
  %if _PM
	dw code2_sel
  %endif
 %endif


cmdline:	db "position limit="
.psp:		db "---- table",13

msg:
.uninstall:		db "UN"
.install:		asciz "INSTALL"
.error:			asciz "Error!",13,10
.ext_error_internal:	asciz "Internal error in EXT command.",13,10
.ext_error_io:		asciz "EXT command got I/O error.",13,10
.ext_error_invalid:	asciz "No or invalid Extension for lDebug header.",13,10
.ext_error_oom:		asciz "Out of memory in EXT command.",13,10
.eld_load_error:db "Extension for lDebug had an error during loading. Code: "
.eld_error_code:asciz "----.",13,10
.yy_error_file_open:	asciz "EXT command failed to open file.",13,10
.invalidcommandline:	asciz "Invalid command line!",13,10
.invalidenvironment:	asciz "Invalid environment!",13,10
.prefixes:		db " kMGT"


%assign _HISTORY_SEPARATE_FIXED 0
%assign _HISTORY_SEPARATE_FIXED 0
%assign _APP_ENV_SIZE 0
%assign _HISTORY 0
%assign _EXT_PUTS_GETLINE 0
%assign _CATCHINT2D 0
%assign _MMXSUPP 0
%assign _EXT_VARIABLES 0
%assign _CONFIG 0
%assign _EXT_PUTS_GETLINE 0
%assign _DT 0
%assign _EXT_PUTS_GETLINE 0
%assign _COUNT 0
%assign _EXPRDUALCODE 0
%assign _EXT_VARIABLES 0

%assign _DEV_ENV_SIZE 0
%assign _BOOT_ENV_SIZE 0
%assign _SCOUNT 0

%include "linkinfo.asm"

	align 16, db 0
eld_linkcall:
.:
	istruc ELD_INSTANCE
at eldiStartCode,	dw 0
at eldiEndCode,		dw .end - .
at eldiStartData,	dw 0
at eldiEndData,		dw 0
at eldiIdentifier,	fill 8, 32, db "LINKCALL"
at eldiFlags,		dw eldifResident
	iend
.to_entry:
	push bx
	mov bl, 0 * (1 + !!_PM)
	jmp @F
	align 8
.to_code1:
	push bx
	mov bl, 2 * (1 + !!_PM)
%if _DUALCODE
	jmp @F
	align 8
.to_code2:
	push bx
	mov bl, 4 * (1 + !!_PM)
%endif
@@:
	lframe 0
	lpar word, origret_farret_seg
	lpar word, origbx_farret_ofs
	lpar word, restore_back_nearret
	 push ax
	lpar dword, transfer
	 push ax
	 push ax
	lenter
	lvar word, restorebx
	 push word [bp + ?origbx_farret_ofs]
 %if _PM
	lvar word, restoredi
	 push di
 %endif
	mov bh, 0
	push word [ss:extcall_table.ret + bx]
	pop word [bp + ?restore_back_nearret]
 %if _PM
	mov di, [ss:pm_2_86m_0]
	mov bx, word [ss:extcall_table.segsel + bx + di]
 %else
	mov bx, word [ss:extcall_table.segsel + bx]
 %endif
	mov bx, word [ss:bx]
	mov word [bp + ?transfer + 2], bx

	mov bx, word [bp + ?origret_farret_seg]
	push word [cs:bx + 2]
	pop word [bp + ?transfer]
	mov word [bp + ?origbx_farret_ofs], bx
 %ifn _PM
	mov word [bp + ?origret_farret_seg], cs
 %endif
 %if _PM
	pop di		; ?restoredi
 %endif
	pop bx		; ?restorebx
	lleave ctx
	pop bp		; ?frame_bp
	retf		; ?transfer
			; still on stack: near return address, far return address

	times 79h - ($ - .) nop
.call_cmd3:
	call .to_code1
	jmp strict short $
	dw cmd3

	align 16
	times 128 - ($ - .) nop
.end:
	endarea eld_linkcall


	align 2
	db 0
	db '0'
line_out:
	resb 264
line_out_end:

	align 16
ext_data_area:
	resb ELDDATASIZE

addsection STACK, align=16 stack class=TEST
	resb 512
stacktop:

group GROUP CODE DATA STACK

addsection ELDCODE, align=16 class=ELDCODE
	resb ELDCODESIZE

[list -]
%assign ii 0
%rep (384 / 32)
addsection RESERVED%[ii], align=16 class=RESERVED
	resb 32 * 1024
%assign ii ii + 1
%endrep
